
local ShowHistory

local Info = package.loaded.regscript or function(...) return ... end
local nfo = Info {_filename or ...,
  name        = "GetMsg extended";
  description = "\"Расширение\" стандартной GetMsg";
  version     = "1.5.1";
  author      = "BAX";
  url         = "https://forum.farmanager.com/viewtopic.php?p=151277";
  id          = "13230B42-55DE-48DA-91ED-CF2B17B95A07";
  help        = function(nfo,name)
                 far.Message( --"Расширение GetMsg:\n\1\n"..
[=[
Варианты вызова:
GetMsg( <number> ) - стандартный far.GetMsg
GetMsg( <имя_файла>, <Тег>, [Quiet, [AddArgs]] )
<имя_файла>  - имя языкового файла (возможно, без "языкового окончания"). Например, EMenu, EMenu.lng, esc_rus.lng
               Если расширение не указано - предполагается .lng.
               Если указанный файл не найден, то ищется последовательно <имя>lang, <имя>_lang, <имя>langh, <имя>_langh, где
                 lang - первые 3 символа настройки языка ФАРа; langh - то же для языка помощи.
               Имя файла может содержать wildcard-ы (как в поиске файлов).
               Также имя_файла может быть таблицей из двух строк: первая - каталог, в котором будет искаться файл;
               вторая - маска файла в стиле Perl RegExp. Если маска не заключена в слэши (/), то предполагается,
               что указан модификатор /…/i (регистронезависимый поиск).
<Тег>        - либо номер (тот же, что указывается в far.GetMsg), либо символьная строка, указанная в языковом файле в виде
               строки //[Тег] (см., например, %FarHome%\FarRus.lng)
<Quiet>=true - подавляет сообщение об ошибке
<AddArgs>    - дополнительные параметры, если в качестве строки указана функция
]=], 'BAX - GetMsg', nil, 'l')


                end;
  history = function() ShowHistory({
{Name='Версия 1.5.1'; Text=[[
 1. Реализована возможность указания не единственного языкового файла, а маски. Маска - либо
    стандартная маска файла, либо массив из двух строк: каталога и собственно маски файла в
    формате Perl-регулярного выражения.
    При этом во всех языковых файлах, соответствующих маске, ОБЯЗАТЕЛЬНО
    указание служебной строки .Language=<язык>; файл ищется именно по этой строке.
 2. Реализована возможность указания set-переменных в имени каталога и файла.
 3. Обработка "кастомных" языковых файлов (*.lng.custom) сделана более универсальной:
    кроме формата name="string" допускается также вариант.
//[name]
Выражение]]};
{Name='Версия 1.4.1'; Text=[[
 1. Реализованы "многострочные строки"
 2. Реализовано указание функции вместо строки]]};
{Name='Версия 1.3.1'; Text=[[
Учтены некоторые замечания [ref=#006600]John Doe[/ref] [url=https://forum.farmanager.com/viewtopic.php?p=151330#p151330](тут)[/url]]};
{Name='Версия 1.2.1'; Text=[[
Для символьного тега добавлен поиск по "личным" настроечным файлам]]};
{Name='Версия 1.1.1'; Text=[[
Заменитель - расширитель far.GetMsg]]};
}, true) end;
  examples = function() ShowHistory({
{Name='Автоматический выбор файла'; Text=[[

Имеется несколько файлов с именами Samp_Eng.lng, Samp_Rus.lng .

Вызов: GetMsg("Samp", "Tag")

Если имеются файлы с именами SampEng.lng, SampRus.lng (без подчёрков), то вызов тот же самый]] };
{Name='Выбор файла по маске'; Text=[[

Имеется несколько файлов с именами Samp_Eng.lng, Samp_Rus.lng,  Samp_Qqq.lng.

Вызов: GetMsg("Samp*.lng", "Tag")

Нужный файл будет выбран по языку, указанному в служебной строке .Language=]]};
{Name='Выбор файла по регулярному выражению'; Text=[=[

         Пример получения строки из стандартного языкового файла FAR-а
         ─────────────────────────────────────────────────────────────

Получение строки, соответствующей кнопке [ Panel ] в диалоге результатов поиска файлов.

Вызов: GetMsg({'%FARHOME%', [[far.*\.lng]]}, "MFindPanel")

Нужный файл будет выбран по языку, указанному в служебной строке .Language=]=]};
}, false) end
  --execute     = function(nfo,name) end;

  --disabled    = false;
  --options     = {};
}
if not nfo then return end
--local O = nfo.options

local F = far.Flags
local C = far.Colors
local tin=table.insert
local BOM = '\xEF\xBB\xBF'

----------------------------------------------------------------------------
local MenuColorIndex = {
  C.COL_MENUTEXT,             -- подложка
  C.COL_MENUBOX,              -- рамка
  C.COL_MENUTITLE,            -- заголовок - верхний и нижний
  C.COL_MENUTEXT,             -- Текст пункта
  C.COL_MENUHIGHLIGHT,        -- HotKey
  C.COL_MENUTEXT,             -- separator
  C.COL_MENUSELECTEDTEXT,     -- Выбранный
  C.COL_MENUSELECTEDHIGHLIGHT,-- Выбранный - HotKey
  C.COL_MENUSCROLLBAR,        -- ScrollBar
  C.COL_MENUDISABLEDTEXT,     -- Disabled
  C.COL_MENUARROWS,           -- '<' & '>' обычные
  C.COL_MENUARROWSSELECTED,   -- '<' & '>' выбранные
  C.COL_MENUARROWSDISABLED,   -- '<' & '>' Disabled
  C.COL_MENUGRAYTEXT,         -- "серый"
  C.COL_MENUSELECTEDGRAYTEXT, -- выбранный "серый"
}
local MenuPalette = {}
for i,v in ipairs(MenuColorIndex) do MenuPalette[i] = v and far.AdvControl(F.ACTL_GETCOLOR,v) end
----------------------------------------------------------------------------
ShowHistory = function(aTable, bInvers)
 local WList=23
 local VerList = {}
 for i=1,#aTable do
  if bInvers then
   tin(VerList, 1, {Text=aTable[i].Name; Descr=aTable[i].Text})
  else
   tin(VerList, {Text=aTable[i].Name; Descr=aTable[i].Text})
  end
  WList = math.max(WList, aTable[i].Name:len()+2)
 end

 local DlgItems, DlgPos = {}, {}
 local h,w=Far.Height-8,Far.Width-8
 local y=2
 local function Add(a) tin(DlgItems, a) end
 Add{"DI_DOUBLEBOX",3,1,w-4,h,0,0,0,0,'History'}
 Add{"DI_LISTBOX", 5,y,5+WList,h-3,VerList,0,0,
     {DIF_LISTNOAMPERSAND=1;DIF_LISTNOCLOSE=1;DIF_LISTNOBOX=1; DIF_FOCUS=1;}
    }; DlgPos.iList=#DlgItems
 local l = ((w-6)-(8+WList)+1) * ((h-3)-y+1)
 Add{"DI_TEXT",8+WList, y, w-6, h-3, 0,0,0, F.DIF_WORDWRAP, (VerList[1].Descr .. (' '):rep(l)):sub(1,l)}; DlgPos.Text = #DlgItems
 --Add{"DI_SINGLEBOX",6+WList,y,6+WList,h-3,0,0,0,0}
 Add{"DI_SINGLEBOX",6+WList,y,6+WList,h-3,0,0,0,0}
 Add{"DI_TEXT",-1,h-2,0,0,0,0,0,F.DIF_SEPARATOR}
 Add{"DI_BUTTON",-1,h-1,-1,0,0,0,0,{DIF_CENTERGROUP=1;DIF_DEFAULTBUTTON=1},'Ok'}; DlgPos.iOk=#DlgItems
 local function DlgProc(hDlg, Msg, Param1, Param2)
  if Msg == F.DN_CTLCOLORDLGLIST then
   return MenuPalette
  elseif Msg == F.DN_LISTCHANGE then
   hDlg:send(F.DM_SETTEXT, DlgPos.Text, (VerList[Param2].Descr .. (' '):rep(l)):sub(1,l))
  --elseif Msg == F.DN_CTLCOLORDLGITEM and Param1 == DlgPos.Text then
  -- Param2[1].ForegroundColor = 0
  -- Param2[1].BackgroundColor = 0xff
  -- Param2[2].ForegroundColor = 0
  -- Param2[2].BackgroundColor = 0xff
  -- return Param2
  end
 end
 far.Dialog(win.Uuid"7494C755-004A-43C8-A183-1FE2E69175B7", -1, -1, w, math.max(h+2, y+3), nil, DlgItems, nil, DlgProc)
end -- ShowHistory
----------------------------------------------------------------------------
local GetMsg =
function (...)
 local Res
 --if #{...} == 1 and tonumber(...) then
 if select("#",...)==1 and type(...)=="number" then
  return far.GetMsg(...)
 end

 local Args=...
 if type(Args) ~= 'table' or select("#", ...) > 1 then
  Args = {File=select(1,...); Tag=select(2,...); Quiet=select(3,...); AddArgs={select(4,...)}}
  if type(Args.File) == 'table' then
   Args.Dir = Args.File[1]
   Args.File = Args.File[2]
   if not Args.File:match"^%b//[ismx]*$" then
    Args.File = '/' .. Args.File .. '/i'
   end
  end
 end
 local File, Dir, Tag, Quiet, AddArgs=Args.File, Args.Dir, Args.Tag, Args.Quiet, Args.AddArgs or {}
 File = File:gsub("%b%%", function(Ext) return win.GetEnv(Ext:sub(2,-2)) end)
 if Dir then Dir = Dir:gsub("%b%%", function(Ext) return win.GetEnv(Ext:sub(2,-2)) end) end
 if File and Tag then
  local function CheckFN_(s)
   if win.GetFileInfo(s) then
    File = s
    return true
   end
  end
  local function SeekTag(AFile, xTag, bCustom)
   local sRes
   local hFile=io.open(AFile, 'r')
   if hFile then
    local Found, iTag=false, -1
    local asRes=nil
    for Line in hFile:lines() do
     -- Столкнулся с ситуацией, когда в начале файла - сигнатура UTF-8 (BOM). Попытка тупо удалить.
     -- Наверняка есть более корректный способ, но на выводе BOM не виден.
     --if string.byte(Line,1) == 239 and    -- 0xEF
     --   string.byte(Line,2) == 187 and    -- 0xBB
     --   string.byte(Line,3) == 191 then   -- 0xBF
     if string.sub(Line,1,3) == BOM then
      Line = string.sub(Line,4)
     end
     Line = Line:match('^%s*(.-)%s*$')
     if bCustom then
      sRes = Line:match('^'..xTag..'%s*=%s*(%b"")')
      if sRes then
       sRes = sRes:sub(2,-2)
       break
      end
     end
     if type(xTag) == 'string' then
      if Found then
       if Line:match"^//%[[^%[%]]+%]$" then
        -- Найден следующий тег
        break
       elseif not Line:match"^//" then
        if asRes == nil then asRes = {} end
        table.insert(asRes, Line)
       end
      else
       Found = Line == '//[' .. xTag .. ']'
      end
     else
      iTag = iTag + 1
      if iTag == xTag then
       sRes = Line:sub(2,-2)
       break
      end
     end
    end
    hFile:close()
    if type(asRes) == 'table' then
     for i=#asRes,1,-1 do
      if asRes[i]:match"%S" then
       break
      else
       table.remove(asRes, i)
      end
     end
     local xFun=loadstring('return '..table.concat(asRes, '\n'))
     if type(xFun) ~= 'function' then
      if not Quiet then far.Message('Некорректное выражение для строки '..tostring(xTag), 'GetMsg', nil, 'w') end
      return
     else
      xFun = xFun()
     end
     if type(xFun) == 'function' then
      sRes = xFun(unpack(AddArgs))
     else
      sRes = xFun
     end
    end
   end
   Res = sRes
   return sRes
  end -- of function SeekTag
  local lang=(Far.GetConfig('Language.Main') or win.GetEnv('FARLANG') or 'English')
  local langh=(Far.GetConfig('Language.Help') or win.GetEnv('FARLANG') or 'English')
  if File:match("^%b//[ismx]*$") or             -- регэксп
     (File:find("*",1,true) or File:find("?",1,true)) then --WildCards
   local function ChkLngFile(_, FName, Lng)
    local ret
    for l in io.lines(FName) do
     if not ret then
      if string.sub(l,1,3) == BOM then
       l = string.sub(l,4)
      end
      if l:sub(1,Lng:len()) == Lng then
       ret = FName
      end
     end
    end
    return ret
   end
   local FoundFile
   if Dir then -- маска - регулярное выражение.
    local function MatchFile(_, FName, Lng)
     if regex.match(FName, File) and
        ChkLngFile('', FName, Lng) then
      return FName
     end
    end -- MatchFile
    FoundFile = far.RecursiveSearch(Dir, '*.lng', MatchFile, F.FRS_RETUPDIR, '.Language=' .. lang .. ',') or
                far.RecursiveSearch(Dir, '*.lng', MatchFile, F.FRS_RETUPDIR, '.Language=' .. langh .. ',') or
                far.RecursiveSearch(Dir, '*.lng', MatchFile, F.FRS_RETUPDIR, '.Language=' .. 'English' .. ',')
   else
    FoundFile = far.RecursiveSearch(mf.fsplit(File, 3), mf.fsplit(File, 12), ChkLngFile, F.FRS_RETUPDIR, '.Language=' .. lang .. ',') or
                far.RecursiveSearch(mf.fsplit(File, 3), mf.fsplit(File, 12), ChkLngFile, F.FRS_RETUPDIR, '.Language=' .. langh .. ',') or
                far.RecursiveSearch(mf.fsplit(File, 3), mf.fsplit(File, 12), ChkLngFile, F.FRS_RETUPDIR, '.Language=' .. 'English' .. ',')
   end
   if not FoundFile then
    if not Quiet then far.Message("Не найдено языковых файлов, соответствующих маске", 'GetMsg', nil, 'w') end
    return Res
   end
   File = FoundFile
  end
  if not win.GetFileInfo(File) then
   lang=lang:sub(1,3)
   langh=langh:sub(1,3)
   local PathN, Ext=mf.fsplit(File, 7), mf.fsplit(File, 8)
   for w in PathN:gmatch('%%[^%%]+%%') do
    PathN = PathN:gsub( '%'..w..'%',win.GetEnv(w:sub(2,-2)) )
   end

   if Ext =='' then Ext = '.lng' end
   if not ( CheckFN_(PathN..Ext) or
            CheckFN_(PathN..lang..Ext) or
            CheckFN_(PathN..'_'..lang..Ext) or
            CheckFN_(PathN..langh..Ext) or
            CheckFN_(PathN..'_'..langh..Ext) or
            CheckFN_(PathN..'Eng'..Ext) or
            CheckFN_(PathN..'_'..'Eng'..Ext)
          ) then
    if not Quiet then far.Message('Языковой файл '..PathN..'[[_]'..lang..'] не найден', 'GetMsg', nil, 'w') end
   end
  end
  if win.GetFileInfo(File) then
   local File0 = File
   if type(Tag) == 'string' and
      ( ( CheckFN_(File .. '.custom') and SeekTag(File, Tag, true) ) or
        --false
        ( CheckFN_(win.GetEnv('FARHOME') .. '\\' .. mf.fsplit(File0, 12) .. '.custom') and SeekTag(File, Tag, true) ) or
        ( CheckFN_(win.GetEnv('FARPROFILE') .. '\\' .. mf.fsplit(File0, 12) .. '.custom') and SeekTag(File, Tag, true) )
      ) then
    return Res
   end
   return SeekTag(File0, Tag, false)
  end
 else
  if not Quiet then far.Message("Требуется указать File= и Tag=", 'GetMsg', nil, 'w') end
 end
 return Res
end -- of function GetMsg
-- Делаю "личный" подраздел _G и записываю туда эту функцию

return GetMsg
