-- Библиотека утилит для работы с таблицами (массивами)
-------------------------------------------------
-- Клонирование таблцы
local function TableClone(Src, Res)
 local function _find(_t, _a)
  for _i,_ in pairs(_t) do
   if _t[_i][1] == _a then
    return _i
   end
  end
  return nil
 end
 if type(Res) ~= 'table' then
  Res = {}
 else
  -- Очистка
  for i,_ in pairs(Res) do
   Res[i] = nil
  end
 end
 local was={}
 for i,v in pairs(Src) do
  if type(v) == 'table' then
   local j=_find(was, v)
   if j then
    Res[i] = was[j][2]
   else
    local aa=TableClone(v)
    table.insert(was, {v,aa})
    Res[i] = aa
   end
  else
   Res[i] = v
  end
 end
 return Res
end
-------------------------------------------------
local function TableToString(arr, sSep, indent, aWas)
 local function _find(_t, _a)
  for _,v in ipairs(_t) do
   if v == _a then
    return true
   end
  end
  _t[#_t+1] = _a
  return false
 end -- _find
 if aWas == nil then aWas = {} end
 local function _Convert(arg, bPoperty)
  if type(arg) == 'string' then
   return ('%q'):format(arg)
  elseif type(arg) == 'function' then
   return bPoperty and 'property '.._Convert(arg()) or 'function(...)'
  elseif type(arg) == 'table' then
   if not _find(aWas, arg) then
    return TableToString(arg, sSep, (indent and indent .. ' '), aWas)
   else
    return '{...}'
   end
  else
   return tostring(arg)
  end
 end -- _Convert
 if type(arr) ~= 'table' then return tostring(arr) end
 local res={}
 -- Сначала определю макс. числовой номер
 local MinN, MaxN
 do
  local i=next(arr)
  while i do
   if type(i) == 'number' then
    MaxN = MaxN and math.max(i, MaxN) or i
    MinN = MinN and math.min(i, MinN) or i
   end
   i = next(arr,i)
  end
 end
 --for _,v in ipairs(arr) do
 if type(MinN) == 'number' then
  for i=MinN, MaxN do
   table.insert(res, (indent or '').._Convert(arr[i]))
  end
 end
 for i,v in pairs(arr) do
  if type(i) ~= 'number' then
   if type(i) == 'string' then
    if i:match"^%a[%w_]*$" then
     table.insert(res, (indent or '')..i..'='.._Convert(v))
    else
     table.insert(res, (indent or '')..'['..("%q"):format(i)..']='.._Convert(v))
    end
   else
    table.insert(res, (indent or '')..'['..tostring(i)..']='.._Convert(v))
   end
  end
 end
 local function _inn()
  if arr.properties then
   for i,v in pairs(arr.properties) do
    if type(i) ~= 'number' then
     table.insert(res, (indent or '')..i..'='.._Convert(v,true))
    end
   end
  end
 end
 pcall(_inn)

 --return '{'..table.concat(res, sSep) .. (indent or '').. '}'
 return '{'..table.concat(res, sSep) .. sSep .. '}'
end
-------------------------------------------------
-- Сравнение таблиц "по значению".
-- сравниваются ординарные значения и таблицы.
-- Проблемы - те же, что и в TabToString
local function TableCompare(arr1, arr2)
 local lRez = #arr1 == #arr2
 if lRez then
  for i,v in ipairs(arr1) do
   if type(arr2[i]) ~= type(v) then return false end
   if mf.index('number string boolean', type(v)) >= 0 then
    if arr2[i] ~= v then return false end
   elseif type(v) == 'table' then
    if not TableCompare(v, arr2[i]) then return false end
   end
  end
 end
end

-- Фунция бинарного поиска.
--local function BinSearch(a_aIndex, a_AsKey, a_lCaseSensitive, a_lExact, a_cmpFunc)
local function BinSearch(...)
 --[[
 Два варианта вызова: позиционный м ключевой
 В ключевом указывается один параметр - таблица с полями:
  ▬ Where         - таблица, в которой ищем
  ▬ What          - Что ищем
  ▬ CaseSensitive - регистрозависимый поиск
  ▬ Exact         - логическое (точный поиск. Если нет - первый превышающий, если точного не найдётся)
  ▬ cmpFunc       - функция сравнения
 В позиционном указываются те же параметры в перечисленном порядке.
 --]]

  local function cmpCaseSens(par1, par2)
   if par1 < par2 then return -1
   elseif par1 > par2 then return 1
   else return 0
   end
  end
  local function cmpCaseInsens(par1, par2)
   return cmpCaseSens(mf.lcase(par1), mf.lcase(par2))
  end
  local aIndex, AsKey, lCaseSensitive, lExact, cmpFunc
  if select('#', ...) == 1 and type(select(1, ...)) == 'table' and type(select(1, ...).Where) == 'table' then
   local a_aIndex = select(1, ...)
   aIndex = a_aIndex.Where
   AsKey = a_aIndex.What
   lExact = a_aIndex.Exact
   lCaseSensitive = a_aIndex.CaseSensitive
   cmpFunc = a_aIndex.cmpFunc
  else
   aIndex = select(1, ...)
   AsKey = select(2, ...)
   lCaseSensitive = select(3, ...)
   lExact = select(4, ...)
   cmpFunc = select(5, ...)
  end
  cmpFunc = cmpFunc or (lCaseSensitive and cmpCaseSens or cmpCaseInsens)
  local i1, i2, i=1,#aIndex
  local sKey = lCaseSensitive and AsKey or mf.lcase(AsKey)
  -- Поиск регистронезависимый
  while i2 > i1 do
   if i2-i1==1 then
    if cmpFunc(aIndex[i1], sKey) == 0 then
     --i=i1
     return i1, aIndex[i1]
    elseif cmpFunc(aIndex[i2], sKey) == 0 then
     --i=i2
     return i2, aIndex[i2]
    else
     --i = -1
     if lExact then
      return
     else
      return i2, aIndex[i2]
     end
    end
   end
   i = math.floor( (i1+i2)/2 )
   local cmp= cmpFunc(aIndex[i], sKey)
   if cmp < 0 then
    i1 = i
   elseif cmp > 0 then
    i2 = i
   else
    while i>1 and cmpFunc(aIndex[i-1], sKey) == 0 do
     i = i - 1
    end
    return i,aIndex[i]
   end
  end -- while i2 > i1
  if i1 == i2 and cmpFunc(aIndex[i1], sKey) == 0 then return i1 end
end -- BinSearch



local TabUtils =
 {Version = '1.1.2';
  TableClone=TableClone;
  TableCompare=TableCompare;
  TableToString=TableToString;
  BinSearch=BinSearch
 }
return TabUtils